/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : IO1.c
**     Project     : ProcessorExpert
**     Processor   : MC56F8257
**     Component   : Init_GPIO
**     Version     : Component 01.090, Driver 01.17, CPU db: 3.00.239
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2013-09-17, 09:26, # CodeGen: 1
**     Abstract    :
**                  This "Init_GPIO" Peripheral Inspector implements the
**                  General Purpose Input/Output (GPIO), basic initialization
**                  and settings.
**     Settings    :
**          Component name                                 : IO1
**          Device                                         : GPIOC
**          Device signal                                  : 
**          Port control                                   : Individual pins
**          Pins                                           : 1
**            Pin                                          : 14
**              Pin                                        : GPIOC14_SDA0_XB_OUT0
**              Pin signal                                 : 
**              Direction                                  : Input
**              Output value                               : 0
**              Pull resistor                              : no pull resistor
**              Open drain                                 : push-pull
**              Interrupt                                  : Enabled
**              Interrupt polarity                         : High
**          Interrupt                                      : 
**            Interrupt                                    : INT_GPIO_C
**            Priority                                     : medium priority
**            ISR name                                     : intX
**          Initialization                                 : 
**            Call Init method                             : yes
**            Enable peripheral clock                      : yes
**     Contents    :
**         Init - void IO1_Init(void);
**
**     Copyright : 1997 - 2013 Freescale Semiconductor, Inc. All Rights Reserved.
**     SOURCE DISTRIBUTION PERMISSIBLE as directed in End User License Agreement.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/
/*!
** @file IO1.c
** @version 01.17
** @brief
**                  This "Init_GPIO" Peripheral Inspector implements the
**                  General Purpose Input/Output (GPIO), basic initialization
**                  and settings.
*/         
/*!
**  @addtogroup IO1_module IO1 module documentation
**  @{
*/         

/* MODULE IO1. */

#include "IO1.h"

/*
** ###################################################################
**
**  The following method(s) must be implemented by the user in one
**  of the following modules:
**
**    #if defined(intX_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(intX_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void intX(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(intX_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**  Modules:
**       ProcessorExpert
**       Events
**
** ###################################################################
*/

/*
** ===================================================================
**     Method      :  IO1_Init (component Init_GPIO)
**     Description :
**         This method initializes registers of the GPIO module
**         according to this Peripheral Initialization Bean settings. 
**         Call this method in the user code to initialize the module.
**         By default, the initialization is made in initialization
**         code; see "Call Init method" property of the bean for more
**         details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void IO1_Init(void)
{
  /* GPIO_C_PUPEN: PU14=0 */
  clrSetReg16Bits(GPIO_C_PUPEN, 0x4000U, 0x00U); 
  /* GPIO_C_PPOUTM: PPMODE14=1 */
  clrSetReg16Bits(GPIO_C_PPOUTM, 0x00U, 0x4000U); 
  /* GPIO_C_DATA: D14=0 */
  clrSetReg16Bits(GPIO_C_DATA, 0x4000U, 0x00U); 
  /* GPIO_C_DDIR: DD14=0 */
  clrSetReg16Bits(GPIO_C_DDIR, 0x4000U, 0x00U); 
  /* GPIO_C_IPOL: IPOL14=0 */
  clrSetReg16Bits(GPIO_C_IPOL, 0x4000U, 0x00U); 
  /* GPIO_C_IEDGE: IES14=1 */
  setReg16Bits(GPIO_C_IEDGE, 0x4000U);  
  /* GPIO_C_IEN: IEN14=1 */
  clrSetReg16Bits(GPIO_C_IEN, 0x00U, 0x4000U); 
}

/* END IO1. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.2 [05.06]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
