/* ###################################################################
**     Filename    : ProcessorExpert.c
**     Project     : ProcessorExpert
**     Processor   : MC56F8257
**     Version     : Driver 01.16
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2013-09-17, 09:24, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    : This project is set to run on the TWR-56F8257 board.  You need to alternately tie C14 HI and LOW to generate interrupts.
**     Contents    : This project illustrates the use of pin sharing with Processor Expert.  C14 is initially configured as GPIO C 14.
**                    Then, after the first rising edge is detected an ISR reconfigures the pin to I2C function.  This makes the reciept of subsequent GPIOC 14 interrupts impossible.
**                    This answers the question: if I configure my pin as I2C, can I still get it to generate GPIO interrupts as NO.
**         No public methods
**
** ###################################################################*/
/*!
** @file ProcessorExpert.c
** @version 01.16
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup ProcessorExpert_module ProcessorExpert module documentation
**  @{
*/         
/* MODULE ProcessorExpert */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "I2C2.h"
#include "IO1.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

 int flag=0 ;
void main(void)
{
  /* Write your local variable definition here */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  flag = 0 ;
  for(;;) {}
}
#pragma interrupt alignsp saveall
void intX (void)
{  
	GPIO_C_IEDGE = 0xffff ; // alias IEDGE is IESR, way to clear the interrupt
	if 	(flag) 	
	   asm(debughlt); // a halt here means interrupt function during I2c mode.
    else 
    	I2C2_ConnectPin(I2C2_SDA_PIN); // data pin is assigned to GPIOC until a GPIOC interrupt actually arrives.
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
asm (nop);
		flag = 1;
}

/* END ProcessorExpert */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.2 [05.06]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
